#!/usr/bin/env python

#NOTES
# may want command on web gui to reset on/all displays


#TODO


import sys
import datetime
import time
from optparse import OptionParser
import xmlrpclib
import os
import re

import ConfigParser

import commands
import socket
import fcntl
import struct
import array
import math
import subprocess





def all_interfaces():
	# it depends on some C structures having a particular size and layout, as well as having the SIOCGIFCONF ioctl number (0x8912) hardcode, different for 64 bit
    max_possible = 128  # arbitrary. raise if needed.
    bytes = max_possible * 32
    s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    names = array.array('B', '\0' * bytes)
    outbytes = struct.unpack('iL', fcntl.ioctl(
        s.fileno(),
        0x8912,  # SIOCGIFCONF
        struct.pack('iL', bytes, names.buffer_info()[0])
    ))[0]
    namestr = names.tostring()
    return [namestr[i:i+32].split('\0', 1)[0] for i in range(0, outbytes, 32)]

def find_ip_address_2(ifname):
    import socket
    import fcntl
    import struct
    #Uses the Linux SIOCGIFADDR ioctl to find the IP address associated with a network interface, given the name of that interface, e.g. "eth0". The address is returned as a string containing a dotted quad.
    s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    return socket.inet_ntoa(fcntl.ioctl(
        s.fileno(),
        0x8915,  # SIOCGIFADDR
        struct.pack('256s', ifname[:15])
    )[20:24])

def my_ip_addresses():
   gsorc,output=commands.getstatusoutput('/sbin/ifconfig')
   ips=[]
   for line in output.splitlines():
      match=re.search(r'^\s+inet addr\:*(\d\.\d\.\d\.\d)\s+',line)
      match=re.search(r'inet addr\:(\d+\.\d+\.\d+\.\d+)\s+',line)
      #if match: ; #includes 127.0.0.1
      if ((match) and (match.group(1) != '127.0.0.1')):
         #first one
         if ( len(ips) == 0 ):
            ips=[match.group(1),]
         else:
            ips.append(match.group(1))

   if ( len(ips) == 0 ):
      ips=['unknown',]
      
   return ips
   
def another_way_to_find_local_active_ip():
  s=socket.socket(socket.AF_INET,socket.SOCK_DGRAM)
  try:
    s.connect(('groovix.net',0))
    print s.getsockname()[0]
  except:
    print "unknown"


#def get_hw_address(ifname):
#    s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
#    info = fcntl.ioctl(s.fileno(), 0x8927,  struct.pack('256s', ifname[:15]))
#    hwaddr = []
#    for char in info[18:24]:
#        hdigit = hex(ord(char))[2:]
#        if len(hdigit) 


def get_hw_address(iface):
    ## (C) Copyright 2007 One Laptop Per Child
    import struct
    import fcntl
    import socket
    s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    fd = s.fileno()
    SIOCGIFHWADDR = 0x8927
    req = fcntl.ioctl(fd, SIOCGIFHWADDR, struct.pack('16s16s', iface, ''))
    s.close()
    ignore1, ignore2, addr_high, addr_low = struct.unpack('>16sHHL8x', req)
    addr = (long(addr_high)<<32) + addr_low
    b0 = addr & 0xFF
    b1 = (addr >> 8) & 0xFF
    b2 = (addr >> 16) & 0xFF
    b3 = (addr >> 24) & 0xFF
    b4 = (addr >> 32) & 0xFF
    b5 = (addr >> 40) & 0xFF
    return "%02X:%02X:%02X:%02X:%02X:%02X" % (b5, b4, b3, b2, b1, b0)

def email_to_send_status_to():
    pass;

def get_uptime():
    pass;

def get_gxconnect_link(workstation):
   status_code=0
   display_order=32
   param_type=12

   linktext="python/gxconnect.py?label="+str(workstation)
   display_text="GX Connect: "
   
   return workstation,'gxconnect_link',linktext,param_type,display_text,display_order,status_code

def get_reboot_link(workstation):
   status_code=0
   display_order=30
   param_type=12

   linktext="python/reboot.py?label="+str(workstation)
   display_text="Reboot: "
   
   return workstation,'reboot_link',linktext,param_type,display_text,display_order,status_code

def get_print_activity(workstation):
   status_code=0
   display_text='Print Activity: '
   display_order=55
   param_type=7

   execlist=["cmon-print-activity"]
   myprocess=subprocess.Popen(execlist,stdout=subprocess.PIPE,stderr=subprocess.PIPE)
   #this will block until command exits
   print_activity=myprocess.communicate()[0].rstrip('\n')
   rc=myprocess.returncode
   if (len(print_activity)==0):
      #no printer activity
      print_activity="none"
   else:
      status_code=2**4
   
   return workstation,'print_activity',print_activity,param_type,display_text,display_order,status_code
   return (workstation,'time_info',time_info,param_type,display_text,display_order,status_code)

def get_gxfilter_state(workstation):
   status_code=0
   display_text=''
   display_order=25
   param_type=12

   execlist=["groovix-filter-state-query"]
   myprocess=subprocess.Popen(execlist,stdout=subprocess.PIPE,stderr=subprocess.PIPE)
   #this will block until command exits
   state=myprocess.communicate()[0]
   rc=myprocess.returncode
   linktext="python/filter.py?state="+str(state).rstrip('\n')+"&label="+str(workstation)
   display_text="Filtering: "
   
   return workstation,'gxfilter_link',linktext,param_type,display_text,display_order,status_code


def get_rez_type(workstation,enablePacRez):
   status_code=0
   display_text=''
   display_order=95
   param_type=1
   if (enablePacRez):
      myvalue="pacrez"
   else:
      myvalue="" 
   return workstation,'rez_type',myvalue,param_type,display_text,display_order,status_code

def get_pactime_link(workstation,user):
   status_code=0
   display_text='PacTime Override: '
   display_order=18
   param_type=12

   linktext="../pactime/session_time.py?username="+str(user)

   return workstation,'pactimelink',linktext,param_type,display_text,display_order,status_code

def get_message_link(workstation):
   status_code=0
   display_text='Send Message: '
   display_order=14
   param_type=12

   linktext="python/send_message.py?label="+str(workstation)

   return workstation,'messagelink',linktext,param_type,display_text,display_order,status_code

def get_terminate_link(workstation):
   status_code=0
   display_text='Terminate Session: '
   display_order=16
   param_type=12

   linktext="python/end_session.py?label="+str(workstation)

   return workstation,'terminatelink',linktext,param_type,display_text,display_order,status_code


def get_vnclink(workstation,display):
   status_code=0
   display_text='VNC Remote Control: '
   display_order=11
   param_type=12
   my_ips=my_ip_addresses()
   if (my_ips[0] == 'unknown'):
     #status 2**7 = error fetching client side data
     status_code=2**7

   #should be done a lot better, maybe get from running vnc process for that display
   # even if display changes websockify is still running at 5820 so keep it there
   #linktext="http://"+my_ips[0]+":582"+display
   linktext="http://"+my_ips[0]+":5820"

   return workstation,'vnclink',linktext,param_type,display_text,display_order,status_code

def get_ip(workstation):
#to handle multiple id addresses, could instead put each one into the db.  arbitrarily define one as the master that is always updated though
   status_code=0
   display_text='IP Addr: '
   display_order=11
   param_type=7
   my_ips=my_ip_addresses()
   iptext=str(my_ips[0])
   if (len(my_ips) > 1):
     status=code=2**6
     for ip in my_ips:
       iptext=iptext+" and "+str(ip)

   return workstation,'ip',iptext,7,display_text,display_order,status_code


def get_hostname(workstation):
   #return socket.gethostbyaddr(socket.gethostname())
   try:
     localhostname=socket.gethostname()
     status_code=0
   except:
     localhostname='unknown'
     status_code=2**7
   return workstation,'hostname',localhostname,7,'Hostname: ',11.0,status_code

def update(cmonserver,myversion,mypass,timezone,workstation,display,send_exec_ack,send_everything):

  rc=-1
  rm='uninitialized return message'
  exec_string=''
  exec_type=0

  command=None

  #if not defined already, get from config file
  config=ConfigParser.ConfigParser()
  config.read("/etc/groovix/cmon.conf")
  if (timezone == None):
    timezone=config.get('cmon','timezone')
  if (cmonserver == None):
    cmonserver=config.get('cmon','cmonserver')

  if (myversion == None):
    myversion=config.get('cmon','customid')
  if (mypass == None):
    mypass=config.get('cmon','custompw')

  try:
      enable_print_activity=int(config.get('cmon','enable_print_activity'))
  except:
      enable_print_activity=None

  try:
      enable_gxfilter=int(config.get('cmon','enable_gxfilter'))
  except:
      enable_gxfilter=None

  try:
      enable_vnclink=int(config.get('cmon','enable_vnclink'))
  except:
      enable_vnclink=1

  try:
      enablePacRez=int(config.get('cmon','enablepacrez'))
  except:
      enablePacRez=None

  try:
      enablePacTime=int(config.get('cmon','enablepactime'))
  except:
      #enablePacTime=None
      #let's turn PacTime display on by default since that is the most common
      enablePacTime=1


  if (display == None):
    try:
      display=os.environ['DISPLAY']
    except:
      display="0";

  if (display != 0):
    match=re.search(r'\:*(\d)\.*(\d)*',display)
    if match:
       display=match.group(1)


  if (workstation == None):
    #f=open('/etc/groovix/label', 'r')
    #workstation=(f.read()).strip()
    workstation=os.popen('groovix-get-parameter GX_LABEL').read().strip()
    #if (display != 0 ):
    #   #if non-zero display, append to workstation
    #   workstation=workstation+":"+display

  get_user_array=get_user(workstation,display)
  curuser=get_user_array[2]
  statusarray=[get_user_array]


  #print "debug send_exec_ack: ",send_exec_ack
  if (send_exec_ack>=1):
     statusarray.append(get_exec_ack(workstation)) 
  if (send_exec_ack!=2):
    #send everything else, this is not just a quick ack
    
    statusarray.append(get_session_time(workstation,curuser))
    statusarray.append(get_user_time_info(workstation,curuser))

    if (send_everything):
      statusarray.append(get_hostname(workstation))
      statusarray.append(get_ip(workstation))
      statusarray.append(get_rez_type(workstation,enablePacRez))
      statusarray.append(get_message_link(workstation))
      statusarray.append(get_terminate_link(workstation))
      statusarray.append(get_reboot_link(workstation))
      statusarray.append(get_gxconnect_link(workstation))
      #statusarray.append(get_uptime(workstation))
      #statusarray.append(get_timezone(workstation,timezone))
      if (enable_vnclink):
          statusarray.append(get_vnclink(workstation,display))


    #always need to send this!
    statusarray.append(get_updated(workstation))


    #and these could change mid session

    if (enable_gxfilter):
        statusarray.append(get_gxfilter_state(workstation))

    if (enable_print_activity):
        statusarray.append(get_print_activity(workstation))

    if (enablePacTime):
      #print "enablePacTime:",enablePacTime
      statusarray.append(get_pactime_link(workstation,curuser))

#other things to possibly report:
# mac address, uptime, load, machine stats like cpu, ram, default printer, printer status, timezone


#very slick, not really necessary way to launch list of functions
#    paramlist=get_hostname,get_updated
#    for get_param in paramlist :
#      get_param()
#      #statusarray.append(get_param())

#another way to execute list of functions
#could have command line or config file params run on the fly
# dispatch('param1'); # will call dispatch_param1()
#def dispatch (self, param):
#    method_name = 'dispatch_' + str(param)
#    method = getattr(self, method_name)
#    method()

  try:
    s = xmlrpclib.ServerProxy(cmonserver)

   
    #statusx=[workstation,parameter,value,type,display_text,display_order,status_code]
    #type and status_code are 20 or 63 ?? bit values, each bit can have a different meaning
   
    # Parameter Types ( param_type ) - 
    # status_code -- each parameter can use different and multiple codes
    # 0 = ignore
    # 1 = just put in db
    # 2 = show in tooltip
    # 4 = show in popup
    # 8 = is URL, show as link
    # 16= 
    # 2**8 = 256 = exec_type=0 = don't exec anything
    # 2**9 =       exec_type=1 = zenity info message
    # 2**10=       exec_type=2 = zenity warning 
    # 2**11=       exec_type=3 = zenity error
    # 2**12=       exec_type=4 = gxconnect (connect to groovix tech support)
    # 2**13=       exec_type=5 = reboot
    # 2**14=       exec_type=6 = change filter state - enable/disable
    # 2**15=       exec_type=7 = terminate session
    # 2**16=       exec_type=8 = user raw string exec
    # 2**17=       exec_type=9 = root raw string exec

    # Status Codes - either a 20 or 63 bit ?? value
    # status_code -- each parameter can use different and multiple codes
    # 0= all ok
    # 1= missing (not stored explicitly - when nothing is in database for that workstation)
    # 2= offline (not stored explicitly - based on time of last update)
    # 4= out_of_order, explicitly set by staff
    # 2**3 = 8  = no active user
    # 2**4 = 16 = printer activity (not online and idle)
    # 2**5 = 32 = machine reserved through pacrez (set on server side)
    # 2**6 = 64 = 
    # 2**7 = 128 =  client side problem fetching data
    # 2**8 = 256 = exec status (0 = acknowledged, 1= pending execution)


    print "sending array:"
    for line in statusarray:
      print str(line)
    print "\n"

    #so the log gets updated more frequently (output buffer is pretty big)
    sys.stdout.flush()


    rc,rm,exec_string,exec_type_raw=s.update(myversion,mypass,statusarray)
    #an encoded exec_type of 0 will = 7 (store, mouseover, popup) + 2**8 (initial exec parameter type)
    try:
       #print "exec_type_raw:",exec_type_raw
       exec_type=int( math.log( ((exec_type_raw-7)/2**8) ,2) )
       #print "exec_type:",exec_type
    except:
       exec_type=0

  #except xmlrpclib.ProtocolError: (OR socket.error: (110, 'Connection timed out')
  #DEBUG# except ZeroDivisionError:
  except:
    rm="Could not connect to "+cmonserver
    rc=1
    exec_string=''
    exec_type=0
    return rc,rm,exec_string,exec_type


  return rc,rm,exec_string,exec_type

def get_timezone(workstation,timezone):
   return (workstation,'timezone',timezone,7,'Timezone: ',90,0)

def get_updated(workstation):
   #return time of last update
   #zero microseconds since we don't care and it clutters display
   current_datetime=(datetime.datetime.now()).replace(microsecond=0)
   return (workstation,'updated',str(current_datetime),7,'Updated: ',40,0)

def get_exec_ack(workstation):
   display_text=0
   display_order=50
   # param_type=7 for just display , no other exec type set, add on 2**8 for exec_type=0
   param_type=7+2**8
   #sending status_code=2**8 would signal there is still a command pending, 0=acknowledged
   status_code=0
   mydisplaystring="Pending Command: "
   myvalue="none"
   return (workstation,'exec',myvalue,param_type,mydisplaystring,display_order,status_code)

def get_user(workstation,display):
   display_text='Active User: '
   display_order=9
   param_type=7
   status_code=2**3
   try:
          #check if dirty so non-authenticated machines show up as used/unused
          #should be enhanced to only do this check on unauthenticated machine, get from cmon config file
          #dfname='/var/lib/groovix/saklock/dirty-display.'+display
          #ufname='/var/lib/groovix/saklock/user.'+display
          #if (os.path.exists(dfname)):
          #   f=open(ufname, 'r')
          #   duser=(f.read()).strip()
          #   status_code=0
          ufname='/var/lib/groovix/session-info/effective-current-user'
          if (os.path.exists(ufname)):
              f=open(ufname, 'r')
              duser=(f.read()).strip()
              status_code=0
          else:
             duser="none"
             status_code=2**3
          return (workstation,'user',duser,param_type,display_text,display_order,status_code)
   #except ZeroDivisionError:
   except:
      #no match found
      return (workstation,'user','none',param_type,display_text,display_order,status_code)


def rest_of_old_get_user(workstation,display):
   #the who command seems to not work sometimes, users don't show up even though they're logged in
   #to debug, get on the machine and use the last command
   gsorc,users=commands.getstatusoutput('who')
   for line in users.splitlines():
      fields=line.split();
      #print "fields 0 is "+fields[0]
      #print "fields 1 is "+fields[1]
      match=re.search(r'\:*(\d)\.*(\d)*',fields[1])
      if match:
        matchdisplay=match.group(1)
        if (display ==  matchdisplay):
          #check if dirty so non-authenticated machines show up as used/unused
          #should be enhanced to only do this check on unauthenticated machine, get from cmon config file
          fname='/dev/shm/'+fields[0]+'.dirty'
          if (os.path.exists(fname)):
             duser=fields[0]
             status_code=0
          else:
             duser="none"
             status_code=2**3
          return (workstation,'user',duser,param_type,display_text,display_order,status_code)

   #no match found
   return (workstation,'user','none',param_type,display_text,display_order,status_code)

def session_usage_in_minutes(username):
    current_time=datetime.datetime.now()
    login_time=get_login_time(username)
    time_diff=current_time-login_time
    #add on a minute since other database-based time usage is set to 1 minute upon login
    return 1+time_diff.days*24*60+time_diff.seconds/60


def get_login_time(username):
    #relies on timestamp written during /etc/gdm/PostLogin/Default, not ideal,
    #but the approach commented out below has problems too
    try:
      last_login_time=os.path.getmtime("/var/lib/groovix/session-info/"+username+".effective-login-time")
    #except ZeroDivisionError:
    except: 
      print "could not find user login stamp at "+"/var/lib/groovix/session-info/"+username+".effective-login-time"
      last_login_time=0
    last_local_time=time.localtime(last_login_time)
    #print last_local_time
    last_login_time=datetime.datetime(*last_local_time[:6])
    return last_login_time


def get_session_time(workstation,user):
   display_text='Minutes Since login: '
   display_order=10
   param_type=7
   
   #default status 2**7 = error fetching client side data
   status_code=2**7
 
   try:
      session_time=session_usage_in_minutes(user)
      if (session_time > 24*60*7):
         #if we're seeing that they've been logged in for over a week, something is wrong (high number gets returned if noone is logged in
         session_time="unknown"
      status_code=0
      return (workstation,'session_time',session_time,param_type,display_text,display_order,status_code)
   #except ZeroDivisionError:
   except:
      return (workstation,'session_time','unknown',param_type,display_text,display_order,status_code)


def rest_of_old_get_session_time(workstation,user):
   gsorc,users=commands.getstatusoutput('who')
   for line in users.splitlines():
     fields=line.split();
     if (fields[0] ==  user):
      #print "fields 0 is "+fields[0]
      #print "fields 1 is "+fields[1]
      #print "fields 2 is "+fields[2]
      #print "fields 3 is "+fields[3]
      try:
        match=re.search(r'(\d+)-(\d+)-(\d+)',fields[2])
        year=int(match.group(1))
        #print year
        month=int(match.group(2))
        #print month
        day=int(match.group(3))
        #print day
        match=re.search(r'(\d+):(\d+)',fields[3])
        hour=int(match.group(1))
        #print hour
        minute=int(match.group(2))
        #print minute

        login_time=datetime.datetime(year, month, day, hour, minute)
        #print login_time
        now=datetime.datetime.now()
        #print now
        session_delta=now-login_time
        #print session_delta.days
        #print session_delta.seconds
        session_time=session_delta.days*24*60 + int(session_delta.seconds/60)
        #session_time=str(session_time)+' minutes'
        status_code=0
        return (workstation,'session_time',session_time,param_type,display_text,display_order,status_code)

      except:
        pass

   return (workstation,'session_time','unknown',param_type,display_text,display_order,status_code)

#print get_session_time('workstation','mpardee')

def get_user_time_info(workstation,user):
   display_text='Time Info:'
   display_order=9
   param_type=7
   status_code=0
   try:
     f=open('/var/lib/groovix/session-info/'+user+'.time-infocache', 'r')
     time_info=(f.read()).strip()
     time_info=re.sub(r'\n', ', ', time_info)
   #except ZeroDivisionError:
   except:
     time_info='none'
     #status 2**7 = error fetching client side data
     status_code=2**7
   return (workstation,'time_info',time_info,param_type,display_text,display_order,status_code)

   

def run():

  parser = OptionParser()
  parser.add_option("-t", "--timezone", dest="timezone", help="timezone of local workstation")
  parser.add_option("-w", "--workstation", dest="workstation", help="local workstation name")
  parser.add_option("-d", "--display", dest="display", help="display name")
  parser.add_option("-v", "--version", dest="myversion", help="customer version code")
  parser.add_option("-p", "--password", dest="mypass", help="customer password")
  parser.add_option("--server", dest="cmonserver", help="full url to cmon server script, include everything from http:// to .py ")

  (options, args) = parser.parse_args()

  #  print options

  myversion=options.myversion
  mypass=options.mypass
  timezone=options.timezone
  workstation=options.workstation
  display=options.display
  cmonserver=options.cmonserver

  rc,message,exe_string,exec_type=update(cmonserver,myversion,mypass,timezone,workstation,display,0,1)
  print message
  exit(rc)

if __name__ == "__main__":
  run()

