#!/usr/bin/env python

import warnings
#cause exception on warnings due to gtk only spitting out warnings and segfaulting if display isn't available
#and importerror is just a warning too!
warnings.filterwarnings('error')
try:
  import gtk
except: 
  print "could not open display"
  exit(1)
import time
import gobject
import sys
import os
from datetime import datetime
import time
import struct
from optparse import OptionParser
import subprocess
import ConfigParser

import cmon


class StatusIcon:

 def on_left_clicked(self,widget):
     pt_status.window.deiconify()
     pt_status.window.present()

 def makeinvisible(self):
     self.icon.set_visible(False)

 def makevisible(self):
     self.icon.set_visible(True)

 def __init__(self):
 
   try:
    self.icon = gtk.status_icon_new_from_file(cmon_dir+'/icons/status_ok.png')
 
    #don't do anything on click for cmon status notifier, only mouseover will give status
    #self.icon.connect('activate', self.on_left_clicked)

    self.makeinvisible()
    self.icon.set_blinking(False)
    #self.icon.set_visible(True)
   except:
    exit(1)


class CmonStatus:

    def ticker(self):
      global tick
      tick=tick-1
      return tick

    def updater(self,icon,window):
      global code
      global oldcode
      global mremain
      global fullmessage 
      global user
      global send_exec_ack
      global firstupdate

      global update_interval
      global update_seconds
      #TODO: don't hardcode, should get from config
      #every 110 seconds if server is too loaded
      #update_interval=110000
      #every 10 seconds for debug
      #update_interval=10000
      #every 59 seconds
      #update_interval=59000
      update_interval=(update_seconds-1)*1000

      #is this the first update?
      if (firstupdate == 1):
          send_everything=1
      else:
          send_everything=0


      rc,fullmessage,exec_string,exec_type=cmon.update(None,None,None,None,None,None,send_exec_ack,send_everything)

      #we've run at least one update
      firstupdate=0;


      #we just sent send_exec_ack (0=no or 1=acknowledge we ran it, 2=quick ack if we are terminating the session), clear it and set it if necessary for next time
      send_exec_ack=0

      #exec if we have a command waiting on server
      if (exec_type == 0):
          #nothing to execute
          pass
      else:
        send_exec_ack=1
        # TODO: IMPROVE THIS!
        # I thought we could just send the ack on the next update, but since that doesn't happen for a whole 'nother minute, if we get a command on the login screen,
        # it will not be acked right away, and someone can log in, and then they'll get the message again!
	# to do this right cmon would have to persist across the login, or remember the pending ack stored in a file
        #we have to explicitly ack right now by running update again, or we may not ack when we expect if someone logs in or this is a termination request

        #send_exec_ack=1
        #instead of explicitly calling another update, just set interval to be fast depending on which type of exec we're doing
        #rc,fullmessage,toonew_exec_string,toonew_exec_type=cmon.update(None,None,None,None,None,None,send_exec_ack,send_everything)
        #we just sent send_exec_ack (0=no or 1=acknowledge we ran it), clear it and set it if necessary for next time
        #send_exec_ack=0

        #update five seconds later to send the exec_ack, and in some cases to show the new state after exec
        update_interval=5000

        print "going to exec type = "+str(exec_type)+" and string = "+str(exec_string)

        if (exec_type == 1):
          #zenity info message
          execlist=['zenity','--info','--text',exec_string]
          subprocess.Popen(execlist,stdout=subprocess.PIPE,stderr=subprocess.PIPE)
          #don't need to do anything with return code, just attempt to run it in the background
        elif (exec_type == 2):
          #zenity warning message
          execlist=['zenity','--warning','--text',exec_string]
          subprocess.Popen(execlist,stdout=subprocess.PIPE,stderr=subprocess.PIPE)
          #don't need to do anything with return code, just attempt to run it in the background
        elif (exec_type == 3):
          #zenity error message
          execlist=['zenity','--error','--text',exec_string]
          subprocess.Popen(execlist,stdout=subprocess.PIPE,stderr=subprocess.PIPE)
          #don't need to do anything with return code, just attempt to run it in the background
        elif (exec_type == 4):
          #gxconnect
          print "running groovix-vnc-connect ",exec_string
          execlist=['groovix-vnc-connect',exec_string]
          subprocess.Popen(execlist,stdout=subprocess.PIPE,stderr=subprocess.PIPE)
          #don't need to do anything with return code, just attempt to run it in the background
        elif (exec_type == 5):
          #immediate reboot
          #but we MUST send an exec_ack first or we will end up constantly rebooting!
          send_exec_ack=2
          rc,fullmessage,toonew_exec_string,toonew_exec_type=cmon.update(None,None,None,None,None,None,send_exec_ack,send_everything)
          execlist=['/sbin/shutdown','-r','now']
          subprocess.Popen(execlist,stdout=subprocess.PIPE,stderr=subprocess.PIPE)
          #don't need to do anything with return code, just attempt to run it in the background
        elif (exec_type == 6):
          #change groovix filter state
          #print "debug: exec_string is"+exec_string
          if (exec_string == "Disable Filtering"):
             execlist=["groovix-filter-off"]
          else:
             execlist=["groovix-filter-on"]
          myprocess=subprocess.Popen(execlist,stdout=subprocess.PIPE,stderr=subprocess.PIPE)
          #this will block until command exits
          #print "return output is: ",myprocess.communicate()[0]
          #print "return code is: ",myprocess.returncode
          #don't need to do anything with return code, just attempt to run it in the background

        elif (exec_type == 7):
          #terminate session
          print "forcefully terminating session due to PacMON web request to do so"
          # /usr/bin/delayed-pac-exit $DELAY $MESSAGE
          execlist=['groovix-session-forced-exit',exec_string]
          subprocess.Popen(execlist,stdout=subprocess.PIPE,stderr=subprocess.PIPE)
          #don't need to do anything with return code, just attempt to run it in the background
          print "backgrounded termination request"

        elif (exec_type == 8):
          #TODO: not implemented yet
          pass
          #exec raw string as user
        elif (exec_type == 9):
          #exec raw string as root (be careful!)
          #TODO: not implemented yet
          #execlist=[exec_string]
          #subprocess.Popen(execlist,stdout=subprocess.PIPE,stderr=subprocess.PIPE)
          #don't need to do anything with return code, just attempt to run it in the background
          pass
        else:
          #undefined for now
          print exec_string



      self.label.set_text("\n"+fullmessage)

      #lowestlimit=10
      if  (rc == 0):
        code='green'
        icon.set_visible(False)
      else:
        code='yellow'
        icon.set_visible(True)


      #old stuff from pactime
      if ( code != oldcode  ):
        if (code == "green"):
          icon.set_from_file(cmon_dir+'icons/status_ok.png')
          window.set_icon_from_file(cmon_dir+'/icons/status_ok.png')
        elif (code == "yellow"):
          icon.set_from_file(cmon_dir+'icons/status_warning.png')
          window.set_icon_from_file(cmon_dir+'/icons/status_warning.png')
        elif (code == "red"):
          icon.set_from_file(cmon_dir+'/icons/status_error.png')
          window.set_icon_from_file(cmon_dir+'/icons/status_error.png')

          #warn explicitly
          icon.set_blinking(True)
	  window.deiconify()
          window.present()
          window.set_urgency_hint(True)
        elif (code == "black"):
          icon.set_blinking(True)
          #warn explicitly
	  window.deiconify()
          window.present()
          window.set_urgency_hint(True)
        elif (code == "noconnection"):
          print "cmon_daemon: no connection"
        elif (code == "exit"):
          print fullmessage

          ##give them some time to see why the session is ending
          #print "cmon_daemon has received the exit signal and triggered delayed-pac-exit"
          #os.system("delayed-pac-exit 5 & ")
          #gtk.main_quit()
          #don't need to exit, this will be killed by delayed-pac-exit!
          #print "cmon_daemon has received the exit signal and triggered delayed-pac-exit"

          #don't exit for now
          #os.system("groovix-pac-forced-logout")
          print "exiting cmon_daemon"
          exit()
          


      ##mtpre="Warning: "
      #mtpost=" minutes remaining in this session"
      ##mremain=mtpre+str(lowestlimit)+mtpost
      #mremain=str(lowestlimit)+mtpost
      ##mtitle=str(lowestlimit)+" minutes remaining in this session"
      #mtitle=mremain
      ##print fullmessage
      ##print mremain
      icon.set_tooltip('cmon '+fullmessage)
      window.set_title('cmon '+fullmessage)
      #window.set_icon_name(mtitle)

      oldcode=code

      #gobject.timeout_add(110000, self.updater, icon, window )  # call updater every 110 seconds
      #DEBUG:
      #gobject.timeout_add(10000, self.updater, icon, window )  # call updater every 10 seconds
      #gobject.timeout_add(60000, self.updater, icon, window )  # call updater every minute
      gobject.timeout_add(update_interval, self.updater, icon, window )  # call updater every minute


    def iconify(self, widget, data=None):
	self.window.iconify()


    def window_state_event(self, widget, event, icon):
        newstate=event.new_window_state
        if (newstate == gtk.gdk.WINDOW_STATE_ICONIFIED):
          self.minimize(icon)

    def minimize(self,icon):
        #print "minimize signal occurred"
        self.window.set_urgency_hint(False)
        icon.set_visible(False)

    def delete_event(self, widget, event, icon, data=None):
        # If you return FALSE in the "delete_event" signal handler,
        # GTK will emit the "destroy" signal. Returning TRUE means
        # you don't want the window to be destroyed.
        #print "delete event occurred"

        icon.set_blinking(False)
        icon.set_visible(True)
        self.window.hide()
        self.window.set_urgency_hint(False)

        return True

    def destroy(self, widget, icon, data=None):
        #shouldn't get here, we expect to catch it in delete_event
        print "Unexpected: destroy signal occurred"

        icon.set_blinking(False)
        icon.set_visible(True)
        self.window.hide()
        self.window.set_urgency_hint(False)

        #gtk.main_quit()

    def __init__(self):
       global fullmessage
       status_icon=StatusIcon()

       # create a new window
       try:
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)

        #define with nothing for now, updater will populate
        self.label = gtk.Label("\n")	
    
        self.updater(status_icon.icon,self.window)

        self.window.connect("delete_event", self.delete_event, status_icon.icon)
    
        self.window.connect("destroy", self.destroy, status_icon.icon)

	#to detect minimize, we only hide status icon on minimize to prevent mouse release 
        # from quickly minimizing the app when your trying to click on the status icon to un-iconify it
        self.window.connect("window-state-event", self.window_state_event,  status_icon.icon)
    
        # Sets the border width of the window.
        self.window.set_border_width(10)

	self.hbox = gtk.HBox(False, 5)
	self.vbox = gtk.VBox(False, 5)
        self.label = gtk.Label("\n"+fullmessage)	
        self.helplabel = gtk.Label('\nMinimize:\n  shows the time remaining in the taskbar at the bottom of the screen.\n\nClose:\n  shows an icon in the status area at the bottom-right of the screen.\n  You can mouse-over the status icon to display the time remaining\n  or click it to restore this dialog.\n')	
        self.helpframe = gtk.Frame("Help")
        self.frame = gtk.Frame("Time Quotas")
        self.frame.add(self.label)
        self.helpframe.add(self.helplabel)
    
        self.button1 = gtk.Button("Minimize")
        self.button2 = gtk.Button("Close")
    
        self.button1.connect("clicked", self.iconify, None)
        self.button2.connect_object("clicked", self.delete_event, self.window, None, status_icon.icon)

        self.vseparator1 = gtk.VSeparator()
        self.vseparator2 = gtk.VSeparator()
	
        self.vbox.pack_start(self.frame, False, False, 0)
        self.vbox.pack_start(self.vseparator1, False, False, 0)
        self.hbox.pack_start(self.button1, True, True, 5)
        self.hbox.pack_start(self.button2, True, True, 5)
        self.vbox.pack_start(self.hbox, False, False, 0)
        self.vbox.pack_start(self.vseparator2, False, False, 0)
        self.vbox.pack_start(self.helpframe, False, False, 0)
    
        self.window.add(self.vbox)

        # show everything
        #self.window.show_all()

        self.window.hide()
        self.window.set_urgency_hint(False)
       #DEBUG# except ZeroDivisionError:
       except:
        print "fatal exception"
        exit(1) 




    def main(self):
        gtk.main()


def run():
    global tick
    global code
    global oldcode
    global pt_status
    global cmon_dir
    global send_exec_ack
    global update_interval
    global update_seconds


    send_exec_ack=0
    global user
    global firstupdate
    firstupdate=1
    cmon_dir='/usr/share/cmon/'
    tick=15
    code="start"
    oldcode=code

    parser = OptionParser()
    parser.add_option("-u", "--user", dest="user", default=None,  help="user name")
    (options, args) = parser.parse_args()
    user=options.user

    #if not defined already, get from config file
    config=ConfigParser.ConfigParser()
    config.read("/etc/groovix/cmon.conf")

    try:
      update_seconds=int(config.get('cmon','update_seconds'))
    except:
      update_seconds=60
    if ( update_seconds < 10 ):
        update_seconds=10;

    #default to 60 seconds
    #update_interval=60000
    update_interval=(update_seconds-1)*1000


    pt_status = CmonStatus()
    pt_status.main()

if __name__ == "__main__":
    run()
